﻿### Multinomial Logit model estimation 推定結果→予想される交通行動だから。勘違い注意

### データファイルの読み込み
setwd("C:/Users/遼史/Desktop")             # 作業ディレクトリを変更する
 getwd()   
#Data <- read.csv("宅抜き.csv",header=T)
Data <- read.csv("ensyu_cleaningall.csv",header=T)

h=0


d=(Data$pur =="業務")
rsyu=subset(Data,d)
Data=subset(Data,d==0)



idj=matrix(0,nrow=length(Data$モニターID),ncol=30)
id=(1:30)
id2=as.integer(id/10)
id3=id-id2*10
g=sprintf("yd0%d%d",id2,id3)

train=0
bus=0
car=0
bike=0
walk=0

for(i in id){
idj[,i]=(Data$モニターID==g[i])#idjは各自の行動したかどうかやから！

j=(Data$モニターID==g[i])
h[i]=sum(j)#合計の計算

  ## 選択結果
  train[i]   <- sum(j*(Data$代表交通手段 =="鉄道"))
  bus[i]     <- sum(j*(Data$代表交通手段 =="バス"))
  car[i]     <- sum(j*(Data$代表交通手段 =="自動車"))
  bike[i]    <- sum(j*(Data$代表交通手段 =="自転車"))
  walk[i]    <- sum(j*(Data$代表交通手段 =="徒歩"))
}
rt=train/h
rbu=bus/h
rc=car/h
rbi=bike/h
rwa=walk/h
s=cbind(rt,rbu,rc,rbi,rwa)


# K平均法でクラスター分析
fit <- kmeans(s, 4)

# 第1、第2主成分でプロット。
library(cluster)
clusplot(s, fit$cluster, color=TRUE, shade=TRUE, labels=2, lines=0)



ds=fit$cluster	#id1が電車男 id2がバスマニア
dss=(ds==ds[1])+2*(ds==ds[2])+3*(ds==ds[8])#1が電車男、2が自動車マニア、３がその他
nnn=idj%*%dss

don=idj%*%id
tradon=idj%*%rt
busdon=idj%*%rbu
cardon=idj%*%rc
bikdon=idj%*%rbi
waldon=idj%*%rwa

## データ数:Dataの行数を数える
hh <- nrow(Data)

## パラメータの初期値の設定

##### Logit model にデータの入力して選択結果を求める過程 #####

  ### パラメータの代入：
  ## 定数項
  b1 <- b[1]
  b2 <- b[2]
  b3 <- b[3]
  b4 <- b[4]

  ## 目的地までの所要時間
  d1 <- b[5]
  
  ## 料金
  f1 <- b[6]
  #慣性関数
  nare<- b[7]

  ## 効用の計算:説明変数にしたい列を入れる．

                                         # 時間                     # 料金                    # 定数項
                                        # 時間                     # 料金                    # 定数項
  train2  <- Data$代替手段生成可否train*exp(d1*Data$総所要時間train/100 +f1*(Data$費用train>600)*(0==las) + b1*matrix(1,nrow =hh,ncol=1) +nare*tradon)#+tram*tradon )
  bus2    <- Data$代替手段生成可否bus  *exp(d1*Data$総所要時間bus/100   +f1*(Data$費用bus>600)*(0==las)   + b2*matrix(1,nrow =hh,ncol=1)+nare*busdon )
  car2    <- Data$代替手段生成可否car  *exp(d1*Data$所要時間car/100                        + b3*matrix(1,nrow =hh,ncol=1)   +nare*cardon  )#+carm*cardon )
  bike2   <- Data$代替手段生成可否bike *exp(d1*Data$所要時間bike/100                       + b4*matrix(1,nrow =hh,ncol=1)   +nare*bikdon  )
  walk2   <- Data$代替手段生成可否walk *exp(d1*Data$所要時間walk/100                                                        +nare*waldon              )#+)




  ### 選択確率の計算
  ## 分母となる，各々のexp(V)の和をつくる
  deno <- (car2 + train2 + bus2 + bike2 + walk2)

  ## それぞれ計算する
  Ptrain <- Data$代替手段生成可否train*(train2 / deno)
  Pbus   <- Data$代替手段生成可否bus  *(bus2   / deno)
  Pcar   <- Data$代替手段生成可否car  *(car2   / deno)
  Pbike  <- Data$代替手段生成可否bike *(bike2  / deno)
  Pwalk  <- Data$代替手段生成可否walk *(walk2  / deno)
#個人別の利用数
train3=apply(idj*Ptrain[,1],2,sum)
bus3=apply(idj*Pbus[,1],2,sum)
car3=apply(idj*Pcar[,1],2,sum)
bike3=apply(idj*Pbike[,1],2,sum)
walk3=apply(idj*Pwalk[,1],2,sum)
h3<-train3+bus3+bike3+car3+walk3#全員のトリップ数
#割合
rt3=train3/h3
rbu3=bus3/h3
rc3=car3/h3
rbi3=bike3/h3
rwa3=walk3/h3

s3=cbind(rt3,rbu3,rc3,rbi3,rwa3)#それぞれの選択割合

#集計
saito<-cbind(Ptrain,Pbus,Pcar,Pbike,Pwalk)
dds<-apply(saito,2,sum)/sum(saito)

